<?php
/*
Plugin Name: bhJaikuWidget
Plugin URI: http://blog.burninghat.net
Description: Add a sidebar widget to display your Jaiku Updates
Version: 0.1
Author: Emmanuel Ostertag alias burningHat
Author URI: http://blog.burninghat.net
License: GPL

Copyright 2008  Emmanuel Ostertag alias burningHat (email : webmaster _at_ burninghat.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function bhJW_widget_init(){
	if ( !function_exists('register_sidebar_widget') )
		return;
		
	function bhJW_widget($args){
		extract($args);
		
		// init widget options
		$options = get_option('bhJaikuWidget');
		$account = $options['account'];
		$title = $options['title'];
		$nb_updates = $options['nb_updates'];
		
		$userstream = 'http://' . $account . '.jaiku.com/feed/';
		
		include_once(ABSPATH . WPINC . '/rss.php');
		$rss = fetch_rss($userstream);
		$maxitems = $nb_updates;
		$items = array_slice($rss->items, 0, $maxitems);
		
		// output	
		echo $before_widget . $before_title . $title . $after_title;
		
		echo "<ul>\n";
		if ( empty($items) ){
			echo'<li>not yet updated</li>';
		} else {
		foreach ( $items as $item){
?>
			<li>
				<?php echo $item['title'] ?> -
				<a href="<?php echo $item['guid'] ?>" title="<?php echo $item['title']; ?>">
					<?php echo $item['jaiku']['timesince'] ?>
				</a>
			</li>
<?php
		}
		}
		
		echo "</ul>\n";
		echo $after_widget;		
	}
	
	// Settings
	function bhJW_widget_control(){
		// get_options
		$options = get_option('bhJaikuWidget');
		
		// if no options, set defaults
		if ( !is_array($options) )
			$options = array(
				'account' => '',
				'title' => __('My Jaiku', 'bhJW'),
				'nb_updates' => '5'
			);
		if ( isset($_POST['bhJW-submit']) ){
			$options['account'] = strip_tags(stripslashes($_POST['bhJW-account']));
			$options['title'] = strip_tags(stripslashes($_POST['bhJW-title']));
			$options['nb_updates'] = stripslashes($_POST['bhJW-nb_updates']);
			
			update_option('bhJaikuWidget', $options);
		}
		
		// prepare datas for display
		$account = htmlspecialchars($options['account'], ENT_QUOTES);
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$nb_updates = (int) htmlspecialchars($options['nb_updates'], ENT_QUOTES);
?>
			<p>
				<label for="bhJW-title"><?php _e('Title:', 'bhJW'); ?><br />
				<input style="width: 100% !important" type="text" id="bhJW-title" name="bhJW-title"  value="<?php echo $title; ?>" /></label>
			</p>
			
			<p>
				<label for="bhJW-account"><?php _e("Your jaiku's account:", 'bhJW'); ?><br />
				<input style="width: 100% !important" type="text" id="bhJW-account" name="bhJW-account" value="<?php echo $account; ?>" /></label>
			</p>
			
			<p>
				<label for="bhJW-nb_updates"><?php _e('Number statuses:', 'bhJW'); ?><br />
				<input type="text" id="bhJW-nb_updates" name="bhJW-nb_updates" value="<?php echo $nb_updates; ?>" /></label>
			</p>
			
			<input type="hidden" id="bhJW-submit" name="bhJW-submit" value="1" />
<?php
	}
	
	// Register widget for display
	register_sidebar_widget('Jaiku', 'bhJW_widget');
	
	// Register settings for widget
	register_widget_control('Jaiku', 'bhJW_widget_control');
}

function bhJW_textdomain(){
	$locale = get_locale();
	if ( empty($locale) ){
		$locale = 'en_US';
	} else {
		$path = basename(str_replace('\\', '/', dirname(__FILE__)));
		$path = ABSPATH.PLUGINDIR.'/'.$path;
		$mofile = $path.'/'.$locale.'.mo';
		load_textdomain('bhJW', $mofile);
	}
}

// Run
add_action('init', 'bhJW_textdomain');
add_action('widgets_init', 'bhJW_widget_init');
?>